# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTIBILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details. 
# This program is based on PHPDocument
# ======================================================================

__version__= '1.0'

from Globals import HTML, HTMLFile, DTMLFile, MessageDialog, Persistent
#from webdav.common import rfc1123_date
#from DateTime import DateTime
import OFS,Acquisition, AccessControl.Role
from OFS.DTMLMethod import decapitate
import Globals, sys, traceback
from OFS.DTMLDocument import DTMLDocument
from AccessControl import getSecurityManager


import os,time,string



manage_addRexxForm = HTMLFile('RexxAddForm', globals())

def manage_addRexx(self, id, title='Rexx object', REQUEST=None, submit=None):
    """Add a Rexx Object """
    ob=RexxDocument(id, title)
    ob.title=title
    id=self._setObject(id, ob)
    if REQUEST is not None:
        try: u=self.DestinationURL()
        except: u=REQUEST['URL1']
        if submit==" Add and Edit ": u="%s/%s" % (u,quote(id))
        REQUEST.RESPONSE.redirect(u+'/manage_main')
    return ''









class RexxDocument(OFS.SimpleItem.Item,DTMLDocument):
    """Rexx object."""    
       
    meta_type = 'Rexx Document'
    icon = 'Rexx.gif'

 
    manage_about = HTMLFile('README', globals())
    manage_help = HTMLFile('help', globals())
    manage_options=({'label':'Edit', 'action':'manage_main'},
                    {'label':'Properties', 'action':'manage_propertiesForm'},
                    {'label':'View', 'action':''},
                    {'label':'Proxy', 'action':'manage_proxyForm'},
                    {'label':'Security', 'action':'manage_access'},
                    {'label':'Help', 'action':'manage_help'},
                   )
   
#    __ac_permissions__=( 
#        ('Change Rexx Document',   ('manage_edit', 'manage_upload', 'PUT')),
#        ('Manage Rexx Document', ('manage_tabs', 'manage_main','manage_about','manage_elementHelp')),
#        )




    def __init__(self, id, title):
        """ init method """
        self.id=id
        self.title=title
        self.globals=''
        self._vars=''
        self.raw="""
/**/
/* enter your Rexx code */   

"""






    def __call__(self, client=None, REQUEST={}, RESPONSE=None, **kw):
        """Render the document given a client object, REQUEST mapping,
        Response, and key word arguments."""

        if hasattr(self, 'aq_explicit'):
            bself=self.aq_explicit
        else:
            bself=self

        security=getSecurityManager()
        security.addContext(self)
        try:
            if client is None:
                #you called this document like <dtml-var your_Rexx_document>
                #from another DTML method or DTML document or Rexx document ...
                r=apply(HTML.__call__, (self, bself, REQUEST), kw)
                if not self._cache_namespace_keys:
                    self.ZCacheable_set(r)
            else:
                #called by web (by URL)
                r=apply(HTML.__call__, (self, (client, bself), REQUEST), kw)
                
            if type(r) is not type('') or RESPONSE is None:
                if not self._cache_namespace_keys:
                    self.ZCacheable_set(r)
        finally:
              security.removeContext(self)
        #r=self.raw
        tmp=string.replace(str(time.time()),".","_")
        file1=tmp+".txt"
        file2=tmp+".out"
        file3=tmp+".err"
        #is Windows ??????
        _iswin32 = (sys.platform == 'win32')
        #on non Windows (Unix ?) use /tmp/ folder
        if not _iswin32:
           file1='/tmp/'+file1
           file2='/tmp/'+file2
           file3='/tmp/'+file3
        f=open(file1,"wt")
        f.write(r)
        f.close()
        #env_sav=os.environ
        QUERY_STRING=""
        if client is not None:
            try:
                for i in REQUEST.form.items():
                    QUERY_STRING=QUERY_STRING+"%s=%s&" % (i[0],i[1])
                try:    os.putenv("QUERY_STRING",QUERY_STRING)
                except:
                   #can't SET QUERY_STRING
                   pass
            except:
                #can't access REQUEST.form
                pass

        x=os.system("rexx "+file1+" > "+file2+" 2> "+file3)
        f=open(file2,"rt")
        lines=f.readlines()
        f.close();
        rez=string.join(lines,'')
        f=open(file3,"rt")
        lines=f.readlines()
        f.close();
        rez=rez+string.join(lines,'')

        try:    os.putenv("QUERY_STRING","")
        except:
          #can't SET QUERY_STRING
          pass

        try:
          os.unlink(file1)
        except: pass
        try:
          os.unlink(file2)
        except: pass
        try:
          os.unlink(file3)
        except: pass
        #os.environ=env_sav
        if RESPONSE is not None:
            rez = decapitate(rez, RESPONSE)

        return rez






Globals.default__class_init__(RexxDocument)

manage_editForm=HTMLFile('RexxEdit', globals())
manage=manage_main=manage_editDocument=manage_editForm





